﻿Option Explicit On
' DClock module - handles persistance and initialization
' Also defines the property struct
Module ModDCalendar

    Structure ClockProperties
        Dim C_Font As String
        Dim C_ForeColor As Color
        Dim C_Backcolor As Color
        Dim C_Mode As Byte ' 0 = 12 hour, 1 = 24 hour
        Dim C_Seconds As Boolean ' True = Show seconds, False = No seconds
        Dim C_Position As Point  ' Position of the clock
        Dim C_ShowCalendar As Boolean ' Whether to show the calendar
    End Structure

    ' This is the global instance of the struct with the clock properties being used
    Public C_Properties As ClockProperties

    ' Gets the saved clock properties - first time, uses project-defined defaults
    Public Function GetClockProperties() As Int32

        Try
            ' Ensure the My.Settings collection is current
            My.Settings.Reload()

            ' Access elements in the My.Settings collection
            C_Properties.C_Backcolor = My.Settings.C_Backcolor
            C_Properties.C_Font = My.Settings.C_Font
            C_Properties.C_ForeColor = My.Settings.C_ForeColor
            C_Properties.C_Mode = My.Settings.C_Mode
            C_Properties.C_Position = My.Settings.C_Position
            C_Properties.C_Seconds = My.Settings.C_Seconds
            C_Properties.C_ShowCalendar = My.Settings.C_ShowCalendar
        Catch ex As Exception
            MsgBox("Error: " & ex.Message, MsgBoxStyle.Critical, "GetClockProperties")
        End Try

    End Function

    ' Saves the current set of clock properties into the My.Settings object
    Public Function SaveClockProperties() As Int32

        Try
            My.Settings.C_Backcolor = C_Properties.C_Backcolor
            My.Settings.C_Font = C_Properties.C_Font
            My.Settings.C_ForeColor = C_Properties.C_ForeColor
            My.Settings.C_Mode = C_Properties.C_Mode
            My.Settings.C_Position = C_Properties.C_Position
            My.Settings.C_Seconds = C_Properties.C_Seconds
            My.Settings.C_ShowCalendar = C_Properties.C_ShowCalendar

            My.Settings.Save()
        Catch ex As Exception
            MsgBox("Error: " & ex.Message, MsgBoxStyle.Critical, "GetClockProperties")
        End Try

    End Function

End Module
